summaryrefslogtreecommitdiffstats
path: root/scripts/relink-lib.sh
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2011-03-01 05:40:38 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2011-03-01 05:40:38 +0000
commitd08229790289e2bbf1e285275dd1bf3189cad078 (patch)
tree19b3947120985c9ef4bc4b54ef1ba9f482baa7af /scripts/relink-lib.sh
parent2892cc195c04f50531f898ce0c8c66d90b11e01b (diff)
base-files: relink uclibc and libgcc libraries to remove leftovers of the statically linked initial libgcc
saves a few kb and gets rid of unused not exported functions as well should also improve the reliability of mklibs git-svn-id: svn://svn.openwrt.org/openwrt/trunk@25800 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'scripts/relink-lib.sh')
-rwxr-xr-xscripts/relink-lib.sh14
1 files changed, 14 insertions, 0 deletions
diff --git a/scripts/relink-lib.sh b/scripts/relink-lib.sh
new file mode 100755
index 000000000..5367b7093
--- /dev/null
+++ b/scripts/relink-lib.sh
@@ -0,0 +1,14 @@
+#!/bin/sh
+[ $# -lt 4 -o -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" ] && {
+ echo "Usage: $0 <cross> <reference> <pic .a> <destination>"
+ exit 1
+}
+
+cross="$1"; shift
+ref="$1"; shift
+pic="$1"; shift
+dest="$1"; shift
+
+SYMBOLS="$(${cross}nm "$ref" | grep -E '........ [TW] ' | awk '$3 {printf "-u%s ", $3}')"
+set -x
+${cross}gcc -nostdlib -nostartfiles -shared -Wl,--gc-sections -o "$dest" $SYMBOLS "$pic" "$@"